
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>IE中的XML DOM / iVAN</title>

    <meta name="description" content="IE中的XML DOM dom|xml 当微软在IE 5.0中第一次加入对XML支持时,他们只是在MSXML ActiveX库(最初是为了在IE 4.0中解析Active Channels的组件)中实现XML的功能.最初的版本并没有打算公开使用,然而随着开发人员逐渐了解这个组件并尝试使用时,微软才意识到这个库的重要性,很快就在IE 4.01中发布了MSXML完全升级版本.MSXML最初还只是IE的一个组件.直到2001年,微软发布了MSXML 3.0,这是一个通过其公司网站独立发布的产品.在2001年晚些时候,微软又发">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">IE中的XML DOM</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>dom|xml</p>
<p>当微软在IE 5.0中第一次加入对XML支持时，他们只是在MSXML ActiveX库（最初是为了在IE 4.0中解析Active Channels的组件）中实现XML的功能。最初的版本并没有打算公开使用，然而随着开发人员逐渐了解这个组件并尝试使用时，微软才意识到这个库的重要性，很快就在IE 4.01中发布了MSXML完全升级版本。MSXML最初还只是IE的一个组件。直到2001年，微软发布了MSXML 3.0，这是一个通过其公司网站独立发布的产品。在2001年晚些时候，微软又发布了MSXML 4.0，并且将其更名为微软XML核心服务组件。MSXML从最初一个基本的、无校验功能的XML解析器，逐渐发展成一个功能强大的组件，能够校验XML文档，进行XSL转化，支持命名空间、XML的简单API（SAX），以及W3C XPath和XML Schema标准，并且每个新版本都在性能上有一定的提升。为了在JavaScript中创建ActiveX对象，微软实现一个新的ActiveXObject类，该类用来实例化ActiveX对象。ActiveXObject类的构造函数包含一个字符串参数，该参数表示要创建的ActiveX对象的版本，在此指的就是XML文档的版本。第一个XML DOM ActiveX对象名为Microsoft.XmlDom，其创建方法如下所示：var oXmlDom = new ActiveXObject("Microsoft.XmlDom");这个新创建的XML DOM对象与其他DOM对象一样，可以用来遍历DOM树，操作DOM节点。到本书截稿为止，MSXML DOM文档共有五个不同的版本，分别是：q Microsoft.XmlDom；q  MSXML2.DOMDocument；q  MSXML2.DOMDocument.3.0；q  MSXML2.DOMDocument.4.0；q  MSXML2.DOMDocument.5.0。MSXML是基于ActiveX的实现，因此只能够在Windows平台上使用。在Mac平台上的IE 5是不提供XML DOM支持的。因为存在五个不同版本，而你总是会使用最新版，所以使用一个函数来判断浏览器所使用的版本是相当有用的。这样就可以确保使用最新的XML支持，获取最佳的性能。下面的函数createDocument()将使你能够创建正确的MSXML DOM文档。function createDocument() {    var aVersions = [ "MSXML2.DOMDocument.5.0",       "MSXML2.DOMDocument.4.0","MSXML2.DOMDocument.3.0",       "MSXML2.DOMDocument","Microsoft.XmlDom"    ];      for (var i = 0; i &lt; aVersions.length; i++) {         try {             var oXmlDom = new ActiveXObject(aVersions[i]);             return oXmlDom;         } catch (oError) {               // 不做任何处理      }    }    throw new Error("MSXML is not installed.");}该函数遍历存放MSXML DOM文档的版本号的aVersions数组，从最新版本MSXML2.DOMDocument.5.0开始尝试创建DOM文档。如果成功创建对象，那么返回该对象且退出createDocument();否则try...catch语句将捕获所抛出的异常，并继续下一次循环，尝试下一个版本。如果MSXML DOM文档创建失败，那么抛出异常，说明MSXML未安装。由于该函数不是一个类，所以用法与其他函数类似，都将返回一个值：var oXmlDom = createDocument();使用createDocument()函数将确保程序使用最新的DOM文档。当创建了XML文档后，下一步就是载入XML数据。1. 在IE中载入XML数据MSXML支持两种载入XML的方法：load()和loadXML()。Load()方法从Web的指定位置载入一个XML文件。与XMLHttp一样，load()方法可以以同步或异步两种模式载入数据。默认情况下，load()方法采用异步模式；如果要采用同步模式，那么必须将MSXML对象的async属性设置为false，代码如下：oXmlDom.async = false;当采用异步模式时，MSXML对象公开了readyState属性，该属性和XMLHttp的readyState属性一样，包含五种状态。此外，DOM文档支持onreadystatechange事件处理函数，可以监控readyState属性。因为异步模式是默认选项，因此将async属性设置为true是可选的：oXmlDom.async = true;oXmlDom.onreadystatechange = function () {    if (oXmlDom.readyState == 4) {       //当document完全载入后，进行某些操作    }};oXmlDom.load("myxml.xml");本示例中，将把虚构的、名为myxml.xml的XML文档载入到XML DOM 文档中。当readyState值为4时，说明文档已经完全载入，则执行if语句中的代码。第二种载入XML数据的方法是loadXML()，该方法与load()方法的主要区别在于从字符串载入XML，而不是根据指定的文件名载入XML。该字符串必须包含正确格式的XML，如下所示：var sXml = "&lt;root&gt;&lt;person&gt;&lt;name&gt;Jeremy McPeak&lt;/name&gt;&lt;/person&gt;&lt;/root&gt;";oXmlDom.loadXML(sXml);在此，oXmlDom文档将载入sXml变量中包含的XML数据。loadXML()方法不需要像load()方法那样检查readyState属性，也不需要设置async属性，因为该方法并不涉及服务器请求。2. 在IE中遍历XML DOM文档XML DOM文档的遍历与HTML DOM的遍历非常类似，因为它们都是节点层次的结构。节点树的最顶部是documentElement属性，包含文档的根元素。使用表4-1中所列出的属性，可以访问文档中任何元素或属性。表4-1 XML DOM属性<br />
<table>
<tr>
<td>属    性</td>
<td>描    述</td>
</tr>
<tr>
<td>attributes</td>
<td>包含当前节点属性的数组</td>
</tr>
<tr>
<td>childNodes</td>
<td>包含子节点数组</td>
</tr>
<tr>
<td>firstChild</td>
<td>指向当前节点的第一个子节点</td>
</tr>
<tr>
<td>lastChild</td>
<td>指向当前节点的最后一个子节点</td>
</tr>
<tr>
<td>nextSibling</td>
<td>返回当前节点的下一个邻居节点</td>
</tr>
<tr>
<td>nodeName</td>
<td>返回当前节点的名字</td>
</tr>
<tr>
<td>nodeType</td>
<td>指定当前节点的XML DOM节点类型</td>
</tr>
<tr>
<td>nodeValue</td>
<td>包含当前节点的文本</td>
</tr>
<tr>
<td>ownerDocument</td>
<td>返回文档的根元素</td>
</tr>
<tr>
<td>parentNode</td>
<td>指向当前节点的父节点</td>
</tr>
<tr>
<td>previousSibling</td>
<td>返回当前节点的前一个邻居节点</td>
</tr>
<tr>
<td>text</td>
<td>返回当前节点的内容或当前节点及其子节点的文本（只有IE才支持的属性）</td>
</tr>
<tr>
<td>xml</td>
<td>以字符串返回当前节点及其子节点的XML（只有IE才支持的属性）</td>
</tr>
</table>
<p>遍历DOM文档并获取数据，是一个很直观的过程。让我们看看下面的XML文档：&lt;?xml version="1.0" encoding="utf-8"?&gt;&lt;books&gt;    &lt;book isbn="0471777781"&gt;Professional Ajax&lt;/book&gt;    &lt;book isbn="0764579088"&gt;Professional JavaScript for Web Developers&lt;/book&gt;    &lt;book isbn="0764557599"&gt;Professional C#&lt;/book&gt;    &lt;book isbn="1861002025"&gt;Professional Visual Basic 6 Databases&lt;/book&gt;&lt;/books&gt;这是一个简单的XML文档，包含一个根元素&lt;books/&gt;以及四个子元素&lt;book/&gt;。以该文档为例，我们可以研究DOM的细节。DOM树是基于节点之间的关系构造的。一个节点可能包含其他节点或者子节点。另一个节点可能与其他节点拥有相同的父节点，我们称之为邻居节点。如果要获取文档中第一个&lt;book/&gt;元素，那么只需简单通过访问firstChild属性就可以达到目的：var oRoot = oXmlDom.documentElement;var oFirstBook = oRoot.firstChild;将documentElement赋给变量oRoot，可以节省程序空间和输入的内容，尽管这并不是必需的。使用firstChild属性可以引用根元素&lt;books/&gt;的第一个子元素&lt;books/&gt;的引用，并将其赋值给变量oFirstBook。使用childNodes集合也可以达到相同的目的：var oFirstBook2 = oRoot.childNodes[0];选择childNodes集合中的第一项将返回根节点的第一个子节点。因为childNodes是JavaScript中的NodeList类型，所以使用length属性可以得到子节点的数量，如下：var iChildren = oRoot.childNodes.length;本示例中，因为文档元素有四个子节点，所以iChildren值为4。正如前面所述，节点可以有子节点，也就意味着它可以有父节点。通过parentNode属性可以选择当前节点的父节点：var oParent = oFirstBook.parentNode;在本小节前面已经提到变量oFirstBook，不过很快，它现在已经是文档中第一个&lt;book/&gt;元素，所以其parentNode属性就是指DOM的documentElement属性，也就是&lt;books/&gt;元素。如果当前节点是book元素，那么如何选择另一个book元素呢？因为&lt;book/&gt;元素有共同的父节点，所以它们互为邻居关系。通过nextSibling和previousSibling属性可以选择当前节点的临近节点。nextSibling属性指向下一个邻居，而previousSibling属性指向前一个邻居：var oSecondBook = oFirstBook.nextSibling;oFirstBook2 = oSecondBook.previousSibling;这段代码引用第二个&lt;book/&gt;元素，并将其赋值给oSecondBook。通过oSecondBook邻居节点对变量oFirstBook2重新赋值，oFirstBook2的值不变。如果节点没有下一个邻居节点，那么nextSibling为null。对于previousSibling也是同样的，如果当前节点没有前一个邻居节点，那么previousSibling也为null。现在我们知道了如何遍历文档结构，接下来要了解的是如何从树的节点获取数据。例如，使用text属性可以得到包含第三个&lt;book/&gt;元素的文本，代码如下：var sText = oRoot.childNodes[2].text;text属性（微软特有的属性）可以得到该节点包含的所有文本节点，该属性相当有用。如果没有text属性，访问文本节点必须：var sText = oRoot.childNodes[2].firstChild.nodeValue;这段代码与前面使用text属性的代码一样得到同样的结果。类似上一个例子，使用childNodes集合引用第三个&lt;book/&gt;元素，而使用firstChild指向&lt;book/&gt;元素的文本节点，因为文本节点在DOM中仍是一个节点。使用nodeValue属性获取当前节点的值，就可以获取文本。这两个示例所产生的结果是相同的，然而使用text属性和使用文本节点的nodeValue属性之间存在一个主要的区别。text属性将得到包含当前元素及其子节点的所有文本节点的值，而nodeValue属性只能得到当前节点的值。它虽然是个有用的属性，但可能会返回比预期值更多的内容。例如，假设我们将XML文档修改成：&lt;?xml version="1.0" encoding="utf-8"?&gt;&lt;books&gt;    &lt;book isbn="0471777781"&gt;        &lt;title&gt;Professional Ajax&lt;/title&gt;        &lt;author&gt;Nicholas C. Zakas, Jeremy McPeak, Joe Fawcett&lt;/author&gt;    &lt;/book&gt;    &lt;book isbn="0764579088"&gt;Professional JavaScript for Web Developers&lt;/book&gt;    &lt;book isbn="0764557599"&gt;Professional C#&lt;/book&gt;    &lt;book isbn="1861002025"&gt;Professional Visual Basic 6 Databases&lt;/book&gt;&lt;/books&gt;新的XML文档在第一个&lt;book/&gt;元素中添加了两个新的子节点：&lt;title/&gt;元素（书名），&lt;author/&gt;元素（作者）。我们再一次使用text属性:alert(oFirstChild.text);代码中没有其他新的内容，我们可以看看图4-1中所显示的结果。<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gzLm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vaW1hZ2UwMDEuanBn.jpg">图  4-1请注意，这时我们将获得&lt;title/&gt;和&lt;author/&gt;元素的文本节点，并将其连接在一起。这就是text与nodeValue的不同之处。nodeValue属性只能得到当前节点的值，而text属性则将得到包含当前节点及其子节点的所有文本节点。MSXML还提供其他一些获取特定节点或数值的方法，最常用的方法是getAttribute()和getElementsByTagName()。getAttribute()方法将接受一个包含属性名称的字符串型参数，并返回属性值。如果指定的属性不存在，那么返回的值为null。我们还将使用本小节前面提到的那个XML文档，请看下列代码：var sAttribute = oFirstChild.getAttribute("isbn");alert(sAttribute);这段代码获取第一个&lt;book/&gt;元素的isbn属性值，并将其赋值给变量sAttribute，然后使用Alert()方法显示该值。getElementsByTagName()方法根据其参数所指定的名字，返回子元素的NodeList。该方法只搜索给定的节点中的元素，所以返回的NodeList不包含任何外部元素。例如：var cBooks = oRoot.getElementsByTagName("book");alert(cBooks.length);这段代码获取文档中所有的&lt;book/&gt;元素，并将返回的NodeList赋值给变量cBooks。对于前面那个XML文档例子而言，警告框将显示找到的四个&lt;book/&gt;元素。如果要获取所有子节点，那么必须用“*”作为getElementsByTagName()方法的参数，其代码如下所示：var cElements = oRoot.getElementsByTagName("*");因为前面的XML文档例子中只包含&lt;book/&gt;元素，所以这段代码的结果与上一个示例相同。3. 在IE中获取XML数据要获取XML数据只需使用一个属性，即xml。该属性将对当前节点的XML数据进行序列化。序列化（serialization）是将对象转换成简单的可存储或可传输格式的过程。xml属性将XML转换成字符串形式，包括完整的标签名称、属性和文本：var sXml = oRoot.xml;alert(sXml);这段代码从文档元素开始序列化XML数据，并将其作为参数传递给alert()方法。下面就是部分已序列化的XML：&lt;books&gt;&lt;book isbn="0471777781"&gt;Professional Ajax&lt;/book&gt;&lt;/books&gt;已序列化的数据可以载入到另一个XML DOM对象，发送到服务器，或者传给另一个页面。通过xml属性返回的已序列化XML数据，取决于当前节点。如果是在documentElement节点使用xml属性，那么将返回整个文档的XML数据；如果只是在&lt;book/&gt;元素上使用它，那么将返回该&lt;book/&gt;元素所包含的XML数据。xml属性是只读属性。如果希望往文档中添加元素，那么必须使用DOM方法来实现。4. 在IE中操作DOM现在为止，我们已经学习如何遍历DOM，从DOM中提取信息，将XML转换成字符串格式。接下来学习的是如何在DOM中添加、删除和替换节点。l   创建节点使用DOM方法可以创建多种不同的节点。第一种就是用createElement()方法创建的元素。向该方法传入一个参数，指明要创建的元素标签名称，并返回一个对XMLDOMElement的引用：var oNewBook = oXmlDom.createElement("book");oXmlDom.documentElement.appendChild(oNewBook);这段代码创建一个新的&lt;book/&gt;元素，并通过appendChild()方法把它添加到documentElement中。appendChild()方法添加由其参数指定的新元素，并且将其作为最后一个子节点。但在该例子中，添加到该文档中的是一个空的&lt;book/&gt;元素，因而还需要为该元素添加一些文本：var oNewBook = oXmlDom.createElement("book");var oNewBookText = oXmlDom.createTextNode("Professional .NET 2.0 Generics");oNewBook.appendChild(oNewBookText);oXmlDom.documentElement.appendChild(oNewBook);这段代码通过createTextNode()方法创建一个文本节点，并通过appendChild()方法把它添加到新创建的&lt;book/&gt;元素中。createTextNode()方法只有一个字符串参数，用来指定文本节点的值。现在已经通过程序创建了新的&lt;book/&gt;元素，为其提供了一个文本节点，并将它添加到文档中。对于这个新元素而言，还需要像其他邻居节点一样，为其设置isbn属性。这很简单，只要通过setAttribute()方法就可以创建属性，该方法适用于所有元素节点。var oNewBook = oXmlDom.createElement("book");var oNewBookText = oXmlDom.createTextNode("Professional .NET 2.0 Generics");oNewBook.appendChild(oNewBookText);oNewBook.setAttribute("isbn","0764559885");oXmlDom.documentElement.appendChild(oNewBook);上面这段代码中，新添加的一行是用来创建isbn属性的，并将其值赋为0764559885。setAttribute()方法有两个参数：第一个参数是属性名，第二个参数则是赋给该属性的值。对于向元素添加属性，IE还提供其他一些方法，不过它们实际上并不比setAttribute()更好用，而且还需要更多的编码。l   删除、替换和插入节点如果能够往文档中添加节点，那么同样意味着可以删除节点。removeChild()方法正是用来实现该功能的。该方法包含一个参数：要删除的节点。例如，要从文档中删除第一个&lt;book/&gt;元素，则可以使用以下代码：var oRemovedChild = oRoot.removeChild(oRoot.firstChild);removeChild()方法返回被删除的子节点，因而oRemoveChild变量将指向已删除的&lt;book/&gt;元素。当拥有对旧节点的引用时，就可以将其放置在文档的任何地方。如果想用oRemovedChild指向的元素来替换第三个&lt;book/&gt;元素，那么可以通过replaceChild()方法来实现，该方法返回被替换的节点：var oReplacedChild = oRoot.replaceChild(oRemovedChild, oRoot.childNodes[2]);replaceChild()方法接受两个参数：新添加的节点和将被替换的节点。在这段代码中，将用oRemovedChild变量引用的节点替换第三个&lt;book/&gt;元素，而被替换节点的引用将存在oReplacedChild变量中。由于oReplaceChild变量是被替换节点的引用，因而可以容易地将其插入到文档中。使用appendChild()方法可以该其添加到子节点列表的最后，也可以使用insertBefore()方法将该节点插入到某个节点之前：oRoot.insertBefore(oReplacedChild, oRoot.lastChild);这段代码将之前被替换的节点插入到最后一个&lt;book/&gt;元素的前面。lastChild属性的用法与firstChild选择第一个子节点非常相似，通过该属性可以获取最后一个子节点。insertBefore()方法接受两个参数：要插入的节点和表示插入点的节点（插入点在该节点之前）。该方法也将返回插入节点的值，但上述例子中并不需要。如你所见，DOM是一个相当强大的接口，通过它可以实现数据的获取、删除和添加等操作。5. 在IE中处理错误在XML数据的载入过程中，可能会由于不同的原因而抛出错误。例如，外部的XML文件找不到，或者XML的格式不正确。为了处理这些情况，MSXML提供了一个包含错误信息的parseError对象。对于每个由MSXML创建的XML DOM文档对象而言，该对象都是其所属的属性值之一。我们可以通过parseError对象公开的与整数0进行比较的errorCode属性来检查错误。如果errorCode不等于0，则表示有错误发生。下面的例子故意设计出现一个错误。var sXml = "&lt;root&gt;&lt;person&gt;&lt;name&gt;Jeremy McPeak&lt;/name&gt;&lt;/root&gt;";var oXmlDom = createDocument();oXmlDom.loadXML(sXml);if (oXmlDom.parseError.errorCode != 0) {    alert("An Error Occurred: " + oXmlDom.parseError.reason);} else {    //当XML载入成功后的操作}大家会注意到，在突出显示的代码行中，&lt;person&gt;元素是不完整的（没有相应的&lt;/person&gt;标签）。由于要载入的XML的格式不正确，因此将产生一个错误。然后errorCode与0进行比较，如果不相等（在本例中就不相等），那么将显示发生错误的警告。要实现该功能，可以使用parseError对象的reason属性来获取错误出现的原因。parseError对象提供了以下属性，能够帮助你更好地了解错误：q  errorCode:错误代码（长整型）；q  filePos:在文件中发生错误的位置（长整型）；q  line:包含错误的代码行的行号（长整型）；q  linePos:在特定行中发生错误的位置（长整型）；q  reason: 错误的原因（字符串型）；q  srcText: 发生错误的代码行内容（字符串型）；q  url: XML文档的URL（字符串型）。尽管这些属性提供了每种错误的信息，但是应该使用哪个属性，则取决于你的需要。<strong>errorCode</strong>属性可以是正数也可以是负数，只有当<strong>errorCode</strong>为0时才表示没有错误发生。  </p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 03:23:19</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%96%b9%e6%b3%95/" title="方法">方法</a>, <a href="https://www.iamivan.net/tag/%e5%b1%9e%e6%80%a7/" title="属性">属性</a>, <a href="https://www.iamivan.net/tag/%e4%b8%80%e4%b8%aa/" title="一个">一个</a>, <a href="https://www.iamivan.net/tag/%e6%96%87%e6%a1%a3/" title="文档">文档</a>, <a href="https://www.iamivan.net/tag/%e5%85%83%e7%b4%a0/" title="元素">元素</a>, <a href="https://www.iamivan.net/tag/%e8%8a%82%e7%82%b9/" title="节点">节点</a>, <a href="https://www.iamivan.net/tag/msxml2-domdocument/" title="MSXML2&period;DOMDocument">MSXML2&period;DOMDocument</a>, <a href="https://www.iamivan.net/tag/xml%e8%8a%82%e7%82%b9/" title="xml节点">xml节点</a>, <a href="https://www.iamivan.net/tag/%e7%bb%99xml%e6%96%87%e6%a1%a3%e6%b7%bb%e5%8a%a0%e6%96%b0/" title="给XML文档添加新">给XML文档添加新</a>, <a href="https://www.iamivan.net/tag/%e8%8a%82%e7%82%b9%e5%b1%9e%e6%80%a7/" title="节点属性">节点属性</a>, <a href="https://www.iamivan.net/tag/%e5%88%9b%e5%bb%ba%e8%8a%82%e7%82%b9/" title="创建节点">创建节点</a>, <a href="https://www.iamivan.net/tag/%e5%b1%9e%e6%80%a7%e8%8a%82%e7%82%b9/" title="属性节点">属性节点</a>, <a href="https://www.iamivan.net/tag/%e8%8e%b7%e5%8f%96dom%e8%8a%82%e7%82%b9/" title="获取DOM节点">获取DOM节点</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>IE中的XML DOM的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OMyn5Jp.html" rel="bookmark">使用XML DOM生成XML&lpar;5&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				dom|xml|生成xml 构造ASP网页         为了创建ASP网页,打开你所熟悉的HTML 编辑器,输入列表B中的代码.确保 Window.Navigate行指向合适的文件夹.要了解其是如何工作的,在Internet Explorer中打开该页.一旦打开后,就会出现一个信息,告诉你XML已经创建了成功,并出现一个 Show 按钮,点击该按钮,IE显示出图E中的XML文档.            图E:我们使用了几种不同的XML DOM 方法来创建完整的XML 文档      XML			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/VMrJR1M.html" rel="bookmark">C&num;中使用XML&mdash;&mdash;实现DOM</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				dom|xml 在前两篇文章中我们讨论了XML文件的读取和写入,但都是基于流模型的解决方案,今天我们就来谈谈在C#中如何实现DOM,DOM确实有它的不足,但在编程工作中它还是不可或缺的技术.下面我们来简单了解一下DOM的相关知识. DOM的全称是Document Object Model(文档对象模型),它是来自W3C的官方标准,它允许按照W3C标准W3C DOM Level1和W3C DOM Level2的规范所定义的规则,通过编程来读取,操纵和修改XML文档.DOM的工作方式是:首先将XML			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrKoPOp.html" rel="bookmark">Visual C&num;中使用XML之实现DOM</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在前两篇文章中我们讨论了XML文件的读取和写入,但都是基于流模型的解决方案,今天我们就来谈谈在C#中如何实现DOM,DOM确实有它的不足,但在编程工作中它还是不可或缺的技术.下面我们来简单了解一下DOM的相关知识. DOM的全称是Document Object Model(文档对象模型),它是来自W3C的官方标准,它允许按照W3C标准W3C DOM Level1和W3C DOM Level2的规范所定义的规则,通过编程来读取,操纵和修改XML文档.DOM的工作方式是:首先将XML文档一次性的装入			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MN77Nxp.html" rel="bookmark">dom-DOM中关于HTML DOM 和XML DOM</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 DOM中关于HTML DOM 和XML DOM 有点捋不清了. 查看js 的window对象,.有这么些内容, HTMLDocument XMLDocument Document document 彼此什么关系,.都有点乱了. 之前一直 DOM 都是用来处理 html,明白document 代表的意思. 现在接触了XML,一下子全乱了. document.implementation.createHTMLDocument(title); //createHTMLDocument 查询帮			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3ZKQ0z.html" rel="bookmark">我的Android进阶之旅------&amp;amp&semi;gt&semi;Android中解析XML 技术详解----&amp;amp&semi;gt&semi;SAX解析、DOM解析、PULL解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				XML在各种开发中都广泛应用,Android也不例外.作为承载数据的一个重要角色,如何读写XML成为Android开发中一项重要的技能.今天就由我向大家介绍一下在Android平台下几种常见的XML解析和创建的方法. 在Android中,常见的XML解析器分别为SAX解析器.DOM解析器和PULL解析器,下面,我将一一向大家详细介绍. SAX解析器: SAX(Simple API for XML)解析器是一种基于事件的解析器,它的核心是事件处理模式,主要是围绕着事件源以及事件处理器来工作的.当事			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Lp5YXap.html" rel="bookmark">用PHP读取和编写XML DOM的实现代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				用 PHP 读取和编写可扩展标记语言(XML)看起来可能有点恐怖.实际上,XML 和它的所有相关技术可能是恐怖的,但是用 PHP 读取和编写 XML 不一定是项恐怖的任务.首先,需要学习一点关于 XML 的知识 -- 它是什么,用它做什么.然后,需要学习如何用 PHP 读取和编写 XML,而有许多种方式可以做这件事. 本文提供了 XML 的简短入门,然后解释如何用 PHP 读取和编写 XML. 什么是 XML? XML 是一种数据存储格式.它没有定义保存什么数据,也没有定义数据的格式.XML 只			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/XMlAl8p.html" rel="bookmark">用PHP读取和编写XML DOM</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				dom|xml     有许多技术可用于用 PHP 读取和编写 XML.本文提供了三种方法读取 XML:使用 DOM 库.使用 SAX 解析器和使用正则表达式.还介绍了使用 DOM 和 PHP 文本模板编写 XML. 用 PHP 读取和编写可扩展标记语言(XML)看起来可能有点恐怖.实际上,XML 和它的所有相关技术可能是恐怖的,但是用 PHP 读取和编写 XML 不一定是项恐怖的任务.首先,需要学习一点关于 XML 的知识 -- 它是什么,用它做什么.然后,需要学习如何用 PHP 读取和编写			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/vMN0wPz.html" rel="bookmark">在PHP中开发XML应用程序之基础篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				xml|程序 一. XML简介 XML(可扩展的标注语言)是一种W3C标准,主要用于Web应用程序和服务器之间实现容易的交互.数据的存储与使用. 使用XML标准编码的数据具有能容易被人和计算机解释的意义和结构.XML数据是平台和应用程序独立的.不用多说,这本身就使XML成为适合于互联网的一个理想的数据交换格式(事实上,它正是因这一用途而被开发的).最近,宽带连接的增长及消费者对于越过任何媒体进行数据共享的应用软件的需求意味着,XML Web服务和应用软件正变得越来越丰富. XML的发明正是为了解			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/XMlVyLz.html" rel="bookmark">构建自己的轻量级XML DOM分析程序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				dom|xml|程序 XML正迅快速的成为数据存储和交换的标准格式流行开来了.现在可用的完整的Java XML分析器非常庞大而且功能强大--但是实现这些强大的功能的同时也要消耗等量的资源.举例来说,流行的Apache Xerces-J分析器超过1.7 MB,而最新的完整的Sun JAXP(用于XML处理的Java应用编程接口)实现程序包超过了3MB.因此使用一个功能强大的XML分析器可能过于浪费.如果配置环境是一个Java小程序或者是一个J2ME应用程序,网络带宽或者系统存储器的制约可能根本不能			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz781db.html" rel="bookmark" class="title">教程&sol;dreamweaver&sol;提高 DW MX 2004代码编辑新功能</a>
					<div>
						dreamweaver|教程 Dreamweaver MX 2004中对源代码编辑的操作功能也有一定的改进,下面我们来看看这些新的改动. 一.右键菜单 在源代码区域如果选中一个范围,点击右键菜单看到新 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMAv5vp.html" rel="bookmark" class="title">学习JS的作品-----N级的联动Select下拉框</a>
					<div>
						js|select|下拉 &lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Transitional//EN&quot; &quot;http: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ybjlB0p.html" rel="bookmark" class="title">不可小视视图对效率的影响力</a>
					<div>
						视图 近日为一家企业开发数据库方面的应用.有两张数据表:A和B,其中A的记录为2万条左右,而B中的数据为200万条以上,现在要求以a.id=b.id为关联进行数据筛选. 为此要求,我做了个视图View ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpkKREp.html" rel="bookmark" class="title">PS鼠绘教程：鼠绘身着紫裙的古典美女</a>
					<div>
						本教程介绍古装人物的鼠绘方法.教程只介绍鼠绘的大致过程,一些细节的刻画并没有详细说明,我们只能根据参考图去慢慢完成.制作的时候最好要懂点鼠绘基础知识,这样才容易上手. 最终效果 1.新建一个大小适当的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ybjkRnM.html" rel="bookmark" class="title">WEB服务代理类的使用</a>
					<div>
						web|web服务   在应用程序和WEB服务之间来回传递包含公共属性和域的类,在处理结构化数据时这个功能很有用:通过创建WEB服务代理类在应用程序内访问WEB服务,其实质是远程WEB服务类的属性和方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXBkk5b.html" rel="bookmark" class="title">&lbrack;JAVA100例&rsqb;062、多线程</a>
					<div>
						/** * &lt;p&gt;Title: 创建多线程&lt;/p&gt; * &lt;p&gt;Description: 使用构造器,创建多线程.&lt;/p&gt; * &lt;p&gt;Copy ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bal88Qz.html" rel="bookmark" class="title">电脑内存不兼容怎么办</a>
					<div>
						我的组装电脑以前用2根512黑金刚 前几天添置一台新的组装电脑,组装电脑配置比以前的组装电脑配置好很多,把新电脑上2根1G内存安装在旧电脑上 现在换回来旧电脑就不能用了 开机几分钟就死机 我查找了原因 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnxQXkb.html" rel="bookmark" class="title">asp cookies实例教程</a>
					<div>
						想利用COOKIE记录当前用户刚才是否发了贴, MyVar=Request.Cookies(&quot;starttime&quot;) if  myvar=&quot;&quot; then Res ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwlorvb.html" rel="bookmark" class="title">从Windows命令行启动MySQL</a>
					<div>
						要想从命令行启动mysqld服务器,你应当启动控制台窗口(或&quot;DOS window&quot;)并输入命令: C:&gt; C:Program FilesMySQLMySQL Server  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQP8vWz.html" rel="bookmark" class="title">如何关闭Word批注框</a>
					<div>
						  1.打开需要关闭批注框的Word文档,在文档里我们可以看到文档里的批注内容. 2.接着点击工具栏的&quot;审阅&quot;→&quot;修订&quot;→&quot;显示标记&quot;,将显 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEWW49p.html" rel="bookmark" class="title">安全证书过期的问题解答</a>
					<div>
						  点评:目前我一直在使用IE6,浏览网页时常常会出现一个小问题.每次当我登录网站,即使我知道这是一个安全可靠的网站,桌面上也会跳出一个窗口,指出该网站存在安全问题- 安全证书过期的常见原因分析: 如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5oQeAb.html" rel="bookmark" class="title">用Word的查找替换功能快速给文档分页</a>
					<div>
						从论坛发现了一个很好的教程集,便复制存放在一个文档里,本想打印出来细细品味,但文档中各篇文章首位相接,没有分页,如此草率打印,也未见完美.我大致翻看了一遍,发现文章编排有一个共同规律:都是以&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGYa9p.html" rel="bookmark" class="title">如何在word文档中插入txt文件</a>
					<div>
						  1.首先,咱们需要在win7旗舰版电脑中打开word程序,接下来,咱们点击窗口上方菜单中的插入,之后,咱们会在上方看到出现另一个菜单,咱们直接选择其中的对象. 2.在弹出来的对象窗口中,咱们就可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBKXG9M.html" rel="bookmark" class="title">mac如何完全卸载软件</a>
					<div>
						  一.使用cleanmymac来卸载 leanmymac是一款专业的mac清理软件,它不仅可以清理mac垃圾,还附带了其它很多的实用功能,卸载软件就是其中之一,也是非常受网友欢迎的一项功能. 优势  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr3aYmp.html" rel="bookmark" class="title">奇米影视盒安装使用教程</a>
					<div>
						一.下载奇米影视盒. 二.双击安装文件进行安装,安装过程如下图: 三.安装完成后双击 图标,打开奇米影视盒,如下图. 四.搜索所要观看的影片 在软件左上角的搜索条中输入影片名,点击&quot;搜索&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWXodqp.html" rel="bookmark" class="title">一键清理系统垃圾文件&period;bat</a>
					<div>
						对于现在清理系统垃圾文件的软件越来越多,而且都是需要从网上下载,安装.这样一系列的过程总是很麻烦,今天小编要教大家的就是利用简单的方法来清理系统的垃圾文件. 在&quot;桌面&quot;上新建一个& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWex7b.html" rel="bookmark" class="title">梦想还需有，因它必实现&mdash;&mdash;发现最新版iOS漏洞，OverSky团队专访</a>
					<div>
						梦想还需有,因它必实现--发现最新版iOS漏洞,OverSky团队专访    &quot;成功了!&quot;,随着一句欢呼声在阿里巴巴西溪园区传出,Cydia的图标出现在一部iOS9.3.4的iPh ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWGwyb.html" rel="bookmark" class="title">Linux的几个网络配置文件</a>
					<div>
						/etc/hosts配置文件 hosts文件的作用相当于DNS,提供IP地址hostname的对应.早期的互联网计算机少,单机hosts文件里足够存放所有联网计算机.不过随着互联网的发展,这就远远不够 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5onVqb.html" rel="bookmark" class="title">《循序渐进学Docker》&mdash;&mdash;1&period;2　Docker的结构与特性</a>
					<div>
						1.2 Docker的结构与特性 通过上一小节的介绍,大家对Docker有一个初步的了解.这一节,再来聊一下Docker的组织结构. 1.2.1 Docker构成 如果把Docker当作一个独立的软件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2P713p.html" rel="bookmark" class="title">5G未来已来：产业生态系统走向协同共赢</a>
					<div>
						随着运营商的网络重构,NB-IoT/eMTC将商用使能垂直行业,网联汽车推动C-V2X发展,以及业界对网络切片.边缘计算等展开深入探索和部署,预示着面向5G商用更进一步. 与此同时,3GPP也加速了5 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJkPKqb.html" rel="bookmark" class="title">javaweb项目中jar包相互引用导致tomcat不能正常发布</a>
					<div>
						问题描述 javaweb项目中jar包相互引用导致tomcat不能正常发布 现在做一个项目是用到结构如下: web项目 A 引用了普通java项目B,我在B里重写了Myservlet,结果两者都引用了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Q5B0p.html" rel="bookmark" class="title">换系统后环境变量缺失</a>
					<div>
						问题描述 换系统后环境变量缺失 电脑原装系统中环境变量有很多项,换了系统后少了很多,一般是什么原因呢? 解决方案 这说明一些环境变量是第三方软件或者电脑生产商设置的,而不是操作系统预设的. 解决方案二 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXwlkQM.html" rel="bookmark" class="title">criteria-Criteria查询时间段是结束时间没有等于</a>
					<div>
						问题描述 Criteria查询时间段是结束时间没有等于 if(map.get(&quot;time&quot;)!=null){ cri.andCrtimeGreaterThanOrEqualTo(( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLm6y5z.html" rel="bookmark" class="title">appserv里面的mysql是不是会覆盖掉自己以前安装的mysql啊？</a>
					<div>
						问题描述 appserv里面的mysql是不是会覆盖掉自己以前安装的mysql啊? appserv里面的mysql是不是会覆盖掉自己以前安装的mysql啊?如何导入以前Mysql的数据? 解决方案 一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWlxGAp.html" rel="bookmark" class="title">《Linux&sol;UNIX系统编程手册（上、下册）》&mdash;&mdash;1&period;2　Linux简史</a>
					<div>
						1.2 Linux简史 术语Linux通常用来指代完整的类UNIX(UNIX-like)操作系统,Linux内核只是其中的一部分.这么定义多少有些措辞不当,因为一般商业Linux发布版中所含的诸多关键 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBo2OM.html" rel="bookmark" class="title">如何在MaxCompute上运行HadoopMR作业</a>
					<div>
						本文用到的 阿里云数加-大数据计算服务MaxCompute产品地址:https://www.aliyun.com/product/odps MaxCompute(原ODPS)有一套自己的MapRedu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjL4odp.html" rel="bookmark" class="title">商业汇票电子化是大势所趋</a>
					<div>
						□华夏银行总行电子银行部 杨慧艳 电子商业汇票作为一种新型的支付结算产品,是将传统商业汇票业务与先进的 网上银行技术相结合,创新出的一种无纸化支付结算工具,是电子商务和供应链融资发展的最好支持工具,具 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3JJ6mz.html" rel="bookmark" class="title">腾龙娱乐中心15331606789你可以说爱情难免走弯路，但我总觉得，这代价未免太大。</a>
					<div>
						浪子会回头吗? 会.但你要知道,所谓浪子回头金不换,是因为一百个浪子里,只有一个会回头,物以稀为贵. 更多的浪子,十八岁浪,二十八岁浪浪浪,三十八岁浪浪浪浪浪浪. 但女人们总有一种可怕的错觉,认为自己 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5RWy6z.html" rel="bookmark" class="title">asp&period;net发送邮件代码&lpar;Gmail、163能发&rpar;</a>
					<div>
						    今天测试了gmail的邮箱能发出去,其它的我测试是发不出去.   #region 发送邮件的函数         /// &lt;summary&gt;         /// 发送邮件函数G ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgwmWZM.html" rel="bookmark" class="title">swift-使用SWIFT开发地图应用  有个疑问求各位大神帮忙</a>
					<div>
						问题描述 使用SWIFT开发地图应用 有个疑问求各位大神帮忙 import UIKit let APIKey = &quot;456502f40fcce736c5a32fbb397ff19c&quot ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
